exercise_05_05: exercise_05_05.o | .gitignore
	g++ $^ -o $@ 

exercise_05_05.ii: exercise_05_05.cpp
	g++ -E $^ -o $@

exercise_05_05.s: exercise_05_05.ii
	g++ -S $^ -o $@

exercise_05_05.o: exercise_05_05.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_05_05" > $@

clean:
	rm -rf *.ii *.s *.o *.out exercise_05_05 .gitignore debug

test: exercise_05_05 
	./exercise_05_05 < test.in > test.out
	diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

test1: exercise_05_05 
	./exercise_05_05 < test1.in > test1.out
	diff test1.out test1.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_05_05.ii exercise_05_05.s
.SECONDARY: exercise_05_05.ii exercise_05_05.s

dbg: debug/exercise_05_05 

debug/exercise_05_05: debug/exercise_05_05.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_05_05.o: debug/exercise_05_05.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_05_05.s: debug/exercise_05_05.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_05_05.ii: exercise_05_05.cpp | debug
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug:
	mkdir -p debug

